;******************************
;*Interface graphique pour SNG*
;*        14/07/2004          *
;*    par Marc Plouhinec      *
;*     www.thebestof.tk       *
;*   m_plouhinec@yahoo.fr     *
;******************************

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.

;Cette interface affiche au maximum 10 programmes

#include "sng10.inc"

 .ORG START_ADDR
 .DB "Interface graphique (SNG)",0

 CALL ChargeProgDansTEXTMEM
 LD A,(NombreDeProgrammes)
 OR A
 RET Z
 CALL AfficheListe
 XOR A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY

Touches:
 ROM_CALL(GET_KEY)
 cp G_CLEAR
 ret z
 cp G_UP
 CALL Z,Haut
 cp G_DOWN
 CALL Z,Bas
 cp G_ENTER
 JR Z,Entree
 halt
 jr Touches

Haut:
 LD A,(ProgrammeSelectionne)
 OR A
 RET Z
 CALL AfficheUnrectangleSurLeAemeProg
 LD A,(ProgrammeSelectionne)
 DEC A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY
 RET

Bas:
 LD A,(NombreDeProgrammes)
 LD B,A
 LD A,(ProgrammeSelectionne)
 DEC B
 CP B
 RET Z
 CALL AfficheUnrectangleSurLeAemeProg
 LD A,(ProgrammeSelectionne)
 INC A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY
 RET

Entree:
;On lance le programme selectionn
;Pour cela on place dans le buffer TEXT_MEM2 un code qui place le nom du programme  l'adresse $806A
;et on appelle EXT_INSTR

 LD A,(ProgrammeSelectionne)
 LD H,0
 LD L,A
 LD BC,10
 CALL MUL_HL_BC
 LD BC,TEXT_MEM
 ADD HL,BC
 INC HL\ INC HL
 LD DE,NomProg
 LD BC,8
 LDIR

 LD DE,TEXT_MEM2
 LD HL,Code
 LD BC,CodeFin-Code
 JP EXT_INSTR


Code:
 LD DE,$806A
 LD HL,NomProg-Code+TEXT_MEM2
 LD BC,8
 LDIR
 RET

NomProg .DB 0,0,0,0,0,0,0,0

CodeFin:




ChargeProgDansTEXTMEM:
;On crer une liste dans TEXT_MEM de 12 lments (10 octets)
;dans laquelle on stocke les adresses des programmes et leur nom
 LD HL,TEXT_MEM
 LD DE,TEXT_MEM+1
 LD (HL),0
 LD BC,127
 LDIR

 XOR A
 LD (NombreDeProgrammes),A
 LD HL,TEXT_MEM
 LD (ListeIndex),HL
 LD HL,VAT_START
 PUSH HL
ChercheProg:
 POP HL
 LD A,6
 LD BC,$ffff
 CPDR
 LD DE,(VAT_END)
 CALL CP_HL_DE
 RET C
 DEC HL
 PUSH HL
 LD (AdresseProgVAT),HL
 LD D,(HL)
 INC HL
 LD E,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD DE,CodeBASIC
 LD C,0
 CALL CP_STRING
 OR A
 JR Z,ChercheProg
 POP HL
 PUSH HL
 LD D,(HL)
 INC HL
 LD E,(HL)
 LD A,D
 CP $94
 JR NZ,CeNestPasLInterface
 LD A,E
 CP $58
 JR NZ,CeNestPasLInterface
;C'est l'interface, pas besoin de l'afficher
 JR ChercheProg
CeNestPasLInterface:
 LD HL,(ListeIndex)
 LD (HL),E
 INC HL
 LD (HL),D
 INC HL
 LD (ListeIndex),HL
;On crit le nom du programme
 LD HL,(AdresseProgVAT)
 DEC HL
 LD B,(HL)
 PUSH BC
EcritLettres:
 DEC HL
 LD A,(HL)
 PUSH HL
 LD HL,(ListeIndex)
 LD (HL),A
 INC HL
 LD (ListeIndex),HL
 POP HL
 DJNZ EcritLettres
 POP BC
 LD HL,(ListeIndex)
 LD A,8
 SUB B
 LD E,A
 LD D,0
 ADD HL,DE
 LD (ListeIndex),HL
 LD A,(NombreDeProgrammes)
 INC A
 CP 11
 JR Z,TropDeProgrammes
 LD (NombreDeProgrammes),A
 JR ChercheProg

TropDeProgrammes:
 POP HL
 RET




AfficheListe:
 SET 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD 
 LD HL,0
 LD (GRAF_CURS),HL
 LD HL,TEXT_MEM
 LD (ListeIndex),HL
AfficheNom:
 LD HL,(ListeIndex)
 CALL LD_HL_MHL
 LD BC,41
 ADD HL,BC
 ROM_CALL(D_ZM_STR)
 LD HL,(GRAF_CURS)
 LD L,0
 LD A,H
 ADD A,6
 LD H,A
 LD (GRAF_CURS),HL
 LD HL,(ListeIndex)
 LD BC,10
 ADD HL,BC
 LD (ListeIndex),HL
 XOR A
 CP (HL)
 RET Z
 INC HL
 CP (HL)
 RET Z
 JR AfficheNom



AfficheUnrectangleSurLeAemeProg:
 LD HL,6*12
 LD C,A
 LD B,0
 CALL MUL_HL_BC
 LD BC,GRAPH_MEM
 ADD HL,BC
 LD B,6*12
AfficheRectangle:
 LD A,(HL)
 XOR $FF
 LD (HL),A
 INC HL
 DJNZ AfficheRectangle
 RET


CodeBASIC .DB $3B,$31,$33,$70,$39,$34,$31,$33,$34,$33,$04,$5C,$4B,$10,0
ListeIndex .DW 0
AdresseProgVAT .DW 0
NombreDeProgrammes .DB 0
ProgrammeSelectionne .DB 0

.END
